﻿Imports INNOBATE.AntiVirus

'IMPORTANT NOTICE: You must read this first before running this example, and agree to the terms and conditions.
'This example is 'as is' and INNOBATE makes no warranties, implied or expressed for any particular purpose whatsoever. It
'only serves as an demonstration on how to use INNOBATE AntiVirus AVClient Object.
'You are more then welcome to modify, alter or extend the code in this example, but cannot pass it off as INNOBATE Ltd's work.
'
'Copyright 2010 INNOBATE LTD.   All other rights implied, expressed, or not expressed are held by INNOBATE Ltd.
'INNOBATE is the trademark of INNOBATE Ltd. 
'Prepared by Shelvin Datt.  Email: innobate@gmail.com

'IMPORTANT: You are required to download and install INNOBATE AntiVirus Basic version 1.0.0.5 or greater
'on the computer system on which you will be running this example code.

'You will need to reference INNOBATEAntiVirusAVClient.dll found in the AVClient folder, if using Visual Studio 2008
'loses the reference. 

Public Class Form1
    'variable x is the Antivirus Client Object used in this example
    'and uses withevents to communicate any events that AVClient object has raised.
    Dim WithEvents x As AVClient

    'Button1 is used create a new instance of the INNOBATE Antivirus Client Ojbect
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Try
            x = New AVClient
        Catch ex As Exception
            MsgBox(ex)
        End Try

    End Sub

    'The ErrorOccured event of AVClient is used to communicate any internal errors that may have
    'occurred during a file scan request.
    Private Sub x_ErrorOccured(ByVal Ex As System.Exception) Handles x.ErrorOccured
        TextBox2.Text = Ex.ToString & vbCrLf & Ex.Source & vbCrLf & Ex.StackTrace.ToString & vbCrLf & Ex.Source & vbCrLf & TextBox2.Text
    End Sub

    'The LostServerConnection even of AVClient is used handle any lose of communication
    'that may occur during any established connection between AVClient Object and INNOBATE
    'AntiVirus Server.
    Private Sub x_LostServerConnection() Handles x.LostServerConnection
        Me.TextBox1.Text = "Server disconneted us, or we lost connection with Server!" & vbCrLf & Me.TextBox1.Text
    End Sub

    'Button2 Click is an example of sending a dummy file, in this case it is just a string, but
    'can be replaced with an actual path of a file.
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        If x IsNot Nothing Then
            x.ScanFile("Hello Server")
        End If
    End Sub

    'Button3 Click is an example of how to disconnect an AVClient from the INNOBATE AntiVirus Server.
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If x IsNot Nothing Then
            x.Dispose()
            x = Nothing
        End If
    End Sub


    'Button4 Click is an example of how to disconnect an AVClient from the INNOBATE AntiVirus Server,
    'and trap/catch/handle any exceptions or errors that may have occurred.
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Try

            If x IsNot Nothing Then
                x.Dispose()
                x = Nothing
            End If
        Catch ex As Exception
            TextBox2.Text = ex.ToString & vbCrLf & ex.Source & vbCrLf & ex.StackTrace.ToString & vbCrLf & ex.Source
        End Try
    End Sub

    'Button5 Click is an example of how to use the OpenFileDialog control to browse files on computer,
    'and later send selected file to INNOBATE AntiVirus Server via AVClient Object.
    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        OpenFileDialog1.ShowDialog()
    End Sub

    'The OpenFileDialog1_FileOK routine below demonstrates how to get the file path from an OpenFileDialog
    'and display it into a textbox, which later can be passed to the AVClient's ScanFile method
    Private Sub OpenFileDialog1_FileOk(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles OpenFileDialog1.FileOk
        TextBox3.Text = OpenFileDialog1.FileName
    End Sub

    'The Button6 Click method demonstrates how to use an AVClient object's ScanFile Method.  In the example below
    'the file path is take for the TextBox3 text property.
    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        If x IsNot Nothing AndAlso TextBox3.Text IsNot String.Empty Then
            x.ScanFile(TextBox3.Text)
        End If
    End Sub

    'Button7 Click demonstrates how to test if varialbe x is already instaniated as an AVClient, and if so then
    'disconnect it, set it to a null instance and then reinistanciate it to an AVClient object instance.
    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Try
            If x IsNot Nothing Then
                x.Dispose()
                x = Nothing
            End If
        Catch ex As Exception
            TextBox2.Text = ex.ToString & vbCrLf & ex.Source & vbCrLf & ex.StackTrace.ToString & vbCrLf & ex.Source
        End Try

        x = New AVClient

    End Sub

    'x_NoVirusFound demonstrates how to handle the NoVirusFound event of an AVClient object instance
    Private Sub x_NoVirusFound(ByVal File As String) Handles x.NoVirusFound
        Me.TextBox1.Text = " No Virus Found in '" & File & "'" & vbCrLf & Me.TextBox1.Text
    End Sub


    'x_ServerConnectionEstablished demonstrates how to handle ServerConnectionEstablished event of an AVClient Ojbect.
    Private Sub x_ServerConnectionEstablished() Handles x.ServerConnectionEstablished
        TextBox2.Text = "Connection to Innobate AV Server established" & vbCrLf & TextBox2.Text
    End Sub

    'x_VirusFound demonstrates how to handle VirusFound event of an AVClient Ojbect. You can change this to suit your needs.
    Private Sub x_VirusFound(ByVal File As String, ByVal VirusName As String, ByVal FoundTime As Date, ByVal QurantineFileName As String) Handles x.VirusFound
        Me.TextBox1.Text = VirusName & " :- Found in '" & File & "' and is now qurantined as " & QurantineFileName & " at the following time: " & FoundTime & vbCrLf & Me.TextBox1.Text
    End Sub


End Class
